> For the complete documentation index, see [llms.txt](https://renewables.docs.helinplatform.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://renewables.docs.helinplatform.com/api-reference/devices.md).

# Devices

## Devices

> List Devices.\
> \
> Returns:\
> &#x20;   List of devices.

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"security":[{"Auth0HTTPBearer":[]}],"components":{"securitySchemes":{"Auth0HTTPBearer":{"scheme":"bearer","type":"http"}},"schemas":{"DeviceResponse":{"properties":{"byteorder":{"nullable":true,"title":"Byteorder","type":"string"},"category":{"title":"Category","type":"string"},"configuration":{"additionalProperties":true,"nullable":true,"title":"Configuration","type":"object"},"created_at":{"format":"date-time","title":"Created At","type":"string"},"data_format":{"nullable":true,"title":"Data Format","type":"string"},"default_value":{"title":"Default Value","type":"integer"},"delay_by":{"nullable":true,"title":"Delay By","type":"number"},"delay_on":{"nullable":true,"title":"Delay On","type":"number"},"device_tag":{"title":"Device Tag","type":"string"},"device_type_id":{"format":"uuid","title":"Device Type Id","type":"string"},"id":{"format":"uuid","title":"Id","type":"string"},"include_in_curtailment":{"title":"Include In Curtailment","type":"boolean"},"max_value":{"title":"Max Value","type":"integer"},"meta_data":{"additionalProperties":true,"nullable":true,"title":"Meta Data","type":"object"},"min_value":{"title":"Min Value","type":"integer"},"modbus_id":{"nullable":true,"title":"Modbus Id","type":"integer"},"modbus_server_host":{"nullable":true,"title":"Modbus Server Host","type":"string"},"modbus_server_port":{"nullable":true,"title":"Modbus Server Port","type":"integer"},"node_id":{"format":"uuid","title":"Node Id","type":"string"},"peak_power_kw":{"nullable":true,"title":"Peak Power Kw","type":"integer"},"scaling":{"nullable":true,"title":"Scaling","type":"integer"},"start_register":{"nullable":true,"title":"Start Register","type":"integer"},"value":{"nullable":true,"title":"Value","type":"integer"},"wordorder":{"nullable":true,"title":"Wordorder","type":"string"}},"required":["device_tag","node_id","device_type_id","max_value","min_value","meta_data","include_in_curtailment","default_value","value","id","created_at","category"],"title":"DeviceResponse","type":"object"},"HTTPValidationError":{"properties":{"detail":{"items":{"$ref":"#/components/schemas/ValidationError"},"title":"Detail","type":"array"}},"title":"HTTPValidationError","type":"object"},"ValidationError":{"properties":{"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"title":"Location","type":"array"},"msg":{"title":"Message","type":"string"},"type":{"title":"Error Type","type":"string"}},"required":["loc","msg","type"],"title":"ValidationError","type":"object"}}},"paths":{"/devices":{"get":{"description":"List Devices.\n\nReturns:\n    List of devices.","operationId":"Devices_api_devices_get","parameters":[{"in":"header","name":"X-Management-Token","required":false,"schema":{"nullable":true,"title":"X-Management-Token","type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"items":{"$ref":"#/components/schemas/DeviceResponse"},"title":"Response Devices Api Devices Get","type":"array"}}},"description":"Successful Response"},"422":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}},"description":"Validation Error"}},"summary":"Devices","tags":["devices"]}}}}
```

## Device Details

> Get Device details.\
> \
> Returns:\
> &#x20;   Device details.\
> &#x20;   HTTP 404 if device not found.

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"security":[{"Auth0HTTPBearer":[]}],"components":{"securitySchemes":{"Auth0HTTPBearer":{"scheme":"bearer","type":"http"}},"schemas":{"DeviceResponse":{"properties":{"byteorder":{"nullable":true,"title":"Byteorder","type":"string"},"category":{"title":"Category","type":"string"},"configuration":{"additionalProperties":true,"nullable":true,"title":"Configuration","type":"object"},"created_at":{"format":"date-time","title":"Created At","type":"string"},"data_format":{"nullable":true,"title":"Data Format","type":"string"},"default_value":{"title":"Default Value","type":"integer"},"delay_by":{"nullable":true,"title":"Delay By","type":"number"},"delay_on":{"nullable":true,"title":"Delay On","type":"number"},"device_tag":{"title":"Device Tag","type":"string"},"device_type_id":{"format":"uuid","title":"Device Type Id","type":"string"},"id":{"format":"uuid","title":"Id","type":"string"},"include_in_curtailment":{"title":"Include In Curtailment","type":"boolean"},"max_value":{"title":"Max Value","type":"integer"},"meta_data":{"additionalProperties":true,"nullable":true,"title":"Meta Data","type":"object"},"min_value":{"title":"Min Value","type":"integer"},"modbus_id":{"nullable":true,"title":"Modbus Id","type":"integer"},"modbus_server_host":{"nullable":true,"title":"Modbus Server Host","type":"string"},"modbus_server_port":{"nullable":true,"title":"Modbus Server Port","type":"integer"},"node_id":{"format":"uuid","title":"Node Id","type":"string"},"peak_power_kw":{"nullable":true,"title":"Peak Power Kw","type":"integer"},"scaling":{"nullable":true,"title":"Scaling","type":"integer"},"start_register":{"nullable":true,"title":"Start Register","type":"integer"},"value":{"nullable":true,"title":"Value","type":"integer"},"wordorder":{"nullable":true,"title":"Wordorder","type":"string"}},"required":["device_tag","node_id","device_type_id","max_value","min_value","meta_data","include_in_curtailment","default_value","value","id","created_at","category"],"title":"DeviceResponse","type":"object"},"HTTPValidationError":{"properties":{"detail":{"items":{"$ref":"#/components/schemas/ValidationError"},"title":"Detail","type":"array"}},"title":"HTTPValidationError","type":"object"},"ValidationError":{"properties":{"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"title":"Location","type":"array"},"msg":{"title":"Message","type":"string"},"type":{"title":"Error Type","type":"string"}},"required":["loc","msg","type"],"title":"ValidationError","type":"object"}}},"paths":{"/devices/{device_id}":{"get":{"description":"Get Device details.\n\nReturns:\n    Device details.\n    HTTP 404 if device not found.","operationId":"Device_details_api_devices__device_id__get","parameters":[{"in":"path","name":"device_id","required":true,"schema":{"format":"uuid","title":"Device Id","type":"string"}},{"in":"header","name":"X-Management-Token","required":false,"schema":{"nullable":true,"title":"X-Management-Token","type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeviceResponse"}}},"description":"Successful Response"},"404":{"content":{"application/json":{"schema":{"properties":{"detail":{"items":{"type":"string"},"title":"Detail","type":"array"}},"title":"Object not found","type":"object"}}},"description":"Object not found"},"422":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}},"description":"Validation Error"}},"summary":"Device Details","tags":["devices"]}}}}
```

## Get Device Response By Reference

> Get Curtailment response using reference, if given during curtailment.\
> \
> Returns:\
> &#x20;   Curtailment Details.\
> &#x20;   HTTP 404 if device or node not found.

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"security":[{"Auth0HTTPBearer":[]}],"components":{"securitySchemes":{"Auth0HTTPBearer":{"scheme":"bearer","type":"http"}},"schemas":{"HTTPValidationError":{"properties":{"detail":{"items":{"$ref":"#/components/schemas/ValidationError"},"title":"Detail","type":"array"}},"title":"HTTPValidationError","type":"object"},"ValidationError":{"properties":{"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"title":"Location","type":"array"},"msg":{"title":"Message","type":"string"},"type":{"title":"Error Type","type":"string"}},"required":["loc","msg","type"],"title":"ValidationError","type":"object"}}},"paths":{"/devices/{device_id}/response/{reference}":{"get":{"description":"Get Curtailment response using reference, if given during curtailment.\n\nReturns:\n    Curtailment Details.\n    HTTP 404 if device or node not found.","operationId":"Get_Device_Response_by_reference_api_devices__device_id__response__reference__get","parameters":[{"in":"path","name":"device_id","required":true,"schema":{"format":"uuid","title":"Device Id","type":"string"}},{"in":"path","name":"reference","required":true,"schema":{"title":"Reference","type":"string"}},{"in":"header","name":"X-Management-Token","required":false,"schema":{"nullable":true,"title":"X-Management-Token","type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"additionalProperties":{"type":"string"},"title":"Response Get Device Response By Reference Api Devices  Device Id  Response  Reference  Get","type":"object"}}},"description":"Successful Response"},"404":{"content":{"application/json":{"schema":{"properties":{"detail":{"items":{"type":"string"},"title":"Detail","type":"array"}},"title":"Object not found","type":"object"}}},"description":"Object not found"},"422":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}},"description":"Validation Error"}},"summary":"Get Device Response By Reference","tags":["devices"]}}}}
```

## List Device Categories

> Get list of device categories per site.

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"security":[{"Auth0HTTPBearer":[]}],"components":{"securitySchemes":{"Auth0HTTPBearer":{"scheme":"bearer","type":"http"}},"schemas":{"DeviceResponse":{"properties":{"byteorder":{"nullable":true,"title":"Byteorder","type":"string"},"category":{"title":"Category","type":"string"},"configuration":{"additionalProperties":true,"nullable":true,"title":"Configuration","type":"object"},"created_at":{"format":"date-time","title":"Created At","type":"string"},"data_format":{"nullable":true,"title":"Data Format","type":"string"},"default_value":{"title":"Default Value","type":"integer"},"delay_by":{"nullable":true,"title":"Delay By","type":"number"},"delay_on":{"nullable":true,"title":"Delay On","type":"number"},"device_tag":{"title":"Device Tag","type":"string"},"device_type_id":{"format":"uuid","title":"Device Type Id","type":"string"},"id":{"format":"uuid","title":"Id","type":"string"},"include_in_curtailment":{"title":"Include In Curtailment","type":"boolean"},"max_value":{"title":"Max Value","type":"integer"},"meta_data":{"additionalProperties":true,"nullable":true,"title":"Meta Data","type":"object"},"min_value":{"title":"Min Value","type":"integer"},"modbus_id":{"nullable":true,"title":"Modbus Id","type":"integer"},"modbus_server_host":{"nullable":true,"title":"Modbus Server Host","type":"string"},"modbus_server_port":{"nullable":true,"title":"Modbus Server Port","type":"integer"},"node_id":{"format":"uuid","title":"Node Id","type":"string"},"peak_power_kw":{"nullable":true,"title":"Peak Power Kw","type":"integer"},"scaling":{"nullable":true,"title":"Scaling","type":"integer"},"start_register":{"nullable":true,"title":"Start Register","type":"integer"},"value":{"nullable":true,"title":"Value","type":"integer"},"wordorder":{"nullable":true,"title":"Wordorder","type":"string"}},"required":["device_tag","node_id","device_type_id","max_value","min_value","meta_data","include_in_curtailment","default_value","value","id","created_at","category"],"title":"DeviceResponse","type":"object"},"HTTPValidationError":{"properties":{"detail":{"items":{"$ref":"#/components/schemas/ValidationError"},"title":"Detail","type":"array"}},"title":"HTTPValidationError","type":"object"},"ValidationError":{"properties":{"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"title":"Location","type":"array"},"msg":{"title":"Message","type":"string"},"type":{"title":"Error Type","type":"string"}},"required":["loc","msg","type"],"title":"ValidationError","type":"object"}}},"paths":{"/sites/{site_id}/device-categories":{"get":{"description":"Get list of device categories per site.","operationId":"List_Device_Categories_api_sites__site_id__device_categories_get","parameters":[{"in":"path","name":"site_id","required":true,"schema":{"format":"uuid","nullable":true,"title":"Site Id","type":"string"}},{"in":"header","name":"X-Management-Token","required":false,"schema":{"nullable":true,"title":"X-Management-Token","type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"additionalProperties":{"items":{"$ref":"#/components/schemas/DeviceResponse"},"type":"array"},"title":"Response List Device Categories Api Sites  Site Id  Device Categories Get","type":"object"}}},"description":"Successful Response"},"404":{"content":{"application/json":{"schema":{"properties":{"detail":{"items":{"type":"string"},"title":"Detail","type":"array"}},"title":"Object not found","type":"object"}}},"description":"Object not found"},"422":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}},"description":"Validation Error"}},"summary":"List Device Categories","tags":["devices"]}}}}
```

## Devices On A Site

> Get list of devices for a given site.\
> \
> Returns:\
> &#x20;   List of devices.\
> &#x20;   HTTP 404 Site not found.

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"security":[{"Auth0HTTPBearer":[]}],"components":{"securitySchemes":{"Auth0HTTPBearer":{"scheme":"bearer","type":"http"}},"schemas":{"DeviceResponse":{"properties":{"byteorder":{"nullable":true,"title":"Byteorder","type":"string"},"category":{"title":"Category","type":"string"},"configuration":{"additionalProperties":true,"nullable":true,"title":"Configuration","type":"object"},"created_at":{"format":"date-time","title":"Created At","type":"string"},"data_format":{"nullable":true,"title":"Data Format","type":"string"},"default_value":{"title":"Default Value","type":"integer"},"delay_by":{"nullable":true,"title":"Delay By","type":"number"},"delay_on":{"nullable":true,"title":"Delay On","type":"number"},"device_tag":{"title":"Device Tag","type":"string"},"device_type_id":{"format":"uuid","title":"Device Type Id","type":"string"},"id":{"format":"uuid","title":"Id","type":"string"},"include_in_curtailment":{"title":"Include In Curtailment","type":"boolean"},"max_value":{"title":"Max Value","type":"integer"},"meta_data":{"additionalProperties":true,"nullable":true,"title":"Meta Data","type":"object"},"min_value":{"title":"Min Value","type":"integer"},"modbus_id":{"nullable":true,"title":"Modbus Id","type":"integer"},"modbus_server_host":{"nullable":true,"title":"Modbus Server Host","type":"string"},"modbus_server_port":{"nullable":true,"title":"Modbus Server Port","type":"integer"},"node_id":{"format":"uuid","title":"Node Id","type":"string"},"peak_power_kw":{"nullable":true,"title":"Peak Power Kw","type":"integer"},"scaling":{"nullable":true,"title":"Scaling","type":"integer"},"start_register":{"nullable":true,"title":"Start Register","type":"integer"},"value":{"nullable":true,"title":"Value","type":"integer"},"wordorder":{"nullable":true,"title":"Wordorder","type":"string"}},"required":["device_tag","node_id","device_type_id","max_value","min_value","meta_data","include_in_curtailment","default_value","value","id","created_at","category"],"title":"DeviceResponse","type":"object"},"HTTPValidationError":{"properties":{"detail":{"items":{"$ref":"#/components/schemas/ValidationError"},"title":"Detail","type":"array"}},"title":"HTTPValidationError","type":"object"},"ValidationError":{"properties":{"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"title":"Location","type":"array"},"msg":{"title":"Message","type":"string"},"type":{"title":"Error Type","type":"string"}},"required":["loc","msg","type"],"title":"ValidationError","type":"object"}}},"paths":{"/sites/{site_id}/devices":{"get":{"description":"Get list of devices for a given site.\n\nReturns:\n    List of devices.\n    HTTP 404 Site not found.","operationId":"Devices_on_a_site_api_sites__site_id__devices_get","parameters":[{"in":"path","name":"site_id","required":true,"schema":{"format":"uuid","nullable":true,"title":"Site Id","type":"string"}},{"in":"header","name":"X-Management-Token","required":false,"schema":{"nullable":true,"title":"X-Management-Token","type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"items":{"$ref":"#/components/schemas/DeviceResponse"},"title":"Response Devices On A Site Api Sites  Site Id  Devices Get","type":"array"}}},"description":"Successful Response"},"404":{"content":{"application/json":{"schema":{"properties":{"detail":{"items":{"type":"string"},"title":"Detail","type":"array"}},"title":"Object not found","type":"object"}}},"description":"Object not found"},"422":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}},"description":"Validation Error"}},"summary":"Devices On A Site","tags":["devices"]}}}}
```

## Devices Per Node On A Site

> Get list of devices for a given site and node.\
> \
> Returns:\
> &#x20;   List of devices.\
> &#x20;   HTTP 404 if Site or Node not found.

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"security":[{"Auth0HTTPBearer":[]}],"components":{"securitySchemes":{"Auth0HTTPBearer":{"scheme":"bearer","type":"http"}},"schemas":{"DeviceResponse":{"properties":{"byteorder":{"nullable":true,"title":"Byteorder","type":"string"},"category":{"title":"Category","type":"string"},"configuration":{"additionalProperties":true,"nullable":true,"title":"Configuration","type":"object"},"created_at":{"format":"date-time","title":"Created At","type":"string"},"data_format":{"nullable":true,"title":"Data Format","type":"string"},"default_value":{"title":"Default Value","type":"integer"},"delay_by":{"nullable":true,"title":"Delay By","type":"number"},"delay_on":{"nullable":true,"title":"Delay On","type":"number"},"device_tag":{"title":"Device Tag","type":"string"},"device_type_id":{"format":"uuid","title":"Device Type Id","type":"string"},"id":{"format":"uuid","title":"Id","type":"string"},"include_in_curtailment":{"title":"Include In Curtailment","type":"boolean"},"max_value":{"title":"Max Value","type":"integer"},"meta_data":{"additionalProperties":true,"nullable":true,"title":"Meta Data","type":"object"},"min_value":{"title":"Min Value","type":"integer"},"modbus_id":{"nullable":true,"title":"Modbus Id","type":"integer"},"modbus_server_host":{"nullable":true,"title":"Modbus Server Host","type":"string"},"modbus_server_port":{"nullable":true,"title":"Modbus Server Port","type":"integer"},"node_id":{"format":"uuid","title":"Node Id","type":"string"},"peak_power_kw":{"nullable":true,"title":"Peak Power Kw","type":"integer"},"scaling":{"nullable":true,"title":"Scaling","type":"integer"},"start_register":{"nullable":true,"title":"Start Register","type":"integer"},"value":{"nullable":true,"title":"Value","type":"integer"},"wordorder":{"nullable":true,"title":"Wordorder","type":"string"}},"required":["device_tag","node_id","device_type_id","max_value","min_value","meta_data","include_in_curtailment","default_value","value","id","created_at","category"],"title":"DeviceResponse","type":"object"},"HTTPValidationError":{"properties":{"detail":{"items":{"$ref":"#/components/schemas/ValidationError"},"title":"Detail","type":"array"}},"title":"HTTPValidationError","type":"object"},"ValidationError":{"properties":{"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"title":"Location","type":"array"},"msg":{"title":"Message","type":"string"},"type":{"title":"Error Type","type":"string"}},"required":["loc","msg","type"],"title":"ValidationError","type":"object"}}},"paths":{"/sites/{site_id}/nodes/{node_id}/devices":{"get":{"description":"Get list of devices for a given site and node.\n\nReturns:\n    List of devices.\n    HTTP 404 if Site or Node not found.","operationId":"Devices_per_node_on_a_site_api_sites__site_id__nodes__node_id__devices_get","parameters":[{"in":"path","name":"site_id","required":true,"schema":{"format":"uuid","nullable":true,"title":"Site Id","type":"string"}},{"in":"path","name":"node_id","required":true,"schema":{"format":"uuid","title":"Node Id","type":"string"}},{"in":"header","name":"X-Management-Token","required":false,"schema":{"nullable":true,"title":"X-Management-Token","type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"items":{"$ref":"#/components/schemas/DeviceResponse"},"title":"Response Devices Per Node On A Site Api Sites  Site Id  Nodes  Node Id  Devices Get","type":"array"}}},"description":"Successful Response"},"404":{"content":{"application/json":{"schema":{"properties":{"detail":{"items":{"type":"string"},"title":"Detail","type":"array"}},"title":"Object not found","type":"object"}}},"description":"Object not found"},"422":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}},"description":"Validation Error"}},"summary":"Devices Per Node On A Site","tags":["devices"]}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://renewables.docs.helinplatform.com/api-reference/devices.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
